
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>DataGuard - 利用Cascaded Redo Log Destinations避免WAN稳定性问题 / iVAN</title>

    <meta name="description" content="DataGuard - 利用Cascaded Redo Log Destinations避免WAN稳定性问题 问题 最近一直头疼于DataGuard环境中万一网络失败将导致的Primary库短时间内无法正常工作的问题. 这个问题的现象基本上是这样:当Primary和Standby之间的网络出现问题,比如说在测试环境中我们拔掉Standby的网线,此时当Primary发生日志切换(Log Switch)的时候,Primary将试图通知Standby同样作归档,但是由于网络不通,就会默认有30秒的TimeOut,而在这30秒的时间内,Primary上的任何DML操作都将被悬停.至今为止我还没有找到很好的办法">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">DataGuard - 利用Cascaded Redo Log Destinations避免WAN稳定性问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>问题</p>
<p>最近一直头疼于DataGuard环境中万一网络失败将导致的Primary库短时间内无法正常工作的问题。</p>
<p>这个问题的现象基本上是这样：<br />当Primary和Standby之间的网络出现问题，比如说在测试环境中我们拔掉Standby的网线，此时当Primary发生日志切换（Log Switch）的时候，Primary将试图通知Standby同样作归档，但是由于网络不通，就会默认有30秒的TimeOut，而在这30秒的时间内，Primary上的任何DML操作都将被悬停。<br />至今为止我还没有找到很好的办法可以有效地缩短这个TimeOut时间，虽然按照文档上说应该可以缩短到最小15秒。即使是15秒，也是无法忍受的，特别是如果DataGuard环境搭建在WAN上，比如说通过2M的DDN专线，那么出现网络故障的几率是比较高的。<br />如果说将有可能由于DataGuard的网络原因而导致主业务库的操作悬停，无论对于客户还是对于我个人而言都是不太容易接受的。</p>
<p>WAN上的网络故障几率较大，那么如果我们换到LAN上，就可以降低这种故障的发生率。由此想到可以利用DataGuard中的Cascaded Redo Log Destinations功能。今天作了此项测试，效果还是很理想的。<br />所谓Cascaded Redo Log Destinations功能，是指A机器（Primary）将redo数据传递给B机器（Standby），然后B机器再将接收到的redo传递给C机器（Standby），这种中转方式在Physical Standby和Logical Standby中都可以实现。如果A，B处于同一个LAN中，而B，C则通过WAN通信，那么即使WAN出现网络问题，也不会影响A将redo传递到B，也就不会影响A的业务进行。</p>
<p>大概配置如下：<br />1。A (Primary)的init参数：<br />*.log_archive_dest_1='LOCATION=/oradata/ctsdb/archive'<br />*.log_archive_dest_2='SERVICE=CTSDB.JUMPER LGWR ASYNC=20480 NET_TIMEOUT=15 MAX_FAILURE=2 REOPEN=10'</p>
<p>2。B (Standby1)的init参数：<br />*.log_archive_dest_1='LOCATION=/oradata/ctsdb/archive'<br />*.log_archive_dest_2='SERVICE=CTSDB.STANDBY' <br />*.standby_archive_dest='/oradata/ctsdb/archive'</p>
<p>3。C (Standby2)的init参数：<br />*.log_archive_dest_1='LOCATION=/oradata/ctsdb/archive' <br />*.standby_archive_dest='/oradata/ctsdb/archive' <br />*.fal_client='ctsdb.standby'<br />*.fal_server='ctsdb.jumper'</p>
<p>其它的配置文件，比如listener.ora和tnsnames.ora，不再赘述。</p>
<p>在B机器上的alertlog中一些比较有趣的地方：<br />Thu Jan 13 12:05:27 2005<br />RFS: Successfully opened standby logfile 4: '/oradata/ctsdb/redo04.log' <br />Thu Jan 13 12:05:33 2005<br />RFS: Successfully opened standby logfile 5: '/oradata/ctsdb/redo05.log' <br />Thu Jan 13 12:05:38 2005<br />RFS: Successfully opened standby logfile 6: '/oradata/ctsdb/redo06.log'<br />RFS: Successfully opened standby logfile 7: '/oradata/ctsdb/redo07.log'<br />RFS: No standby redo logfiles of size 6144 blocks available</p>
<p>以前的测试和Freelists中的一些邮件列表的讨论都表明在DataGuard环境中我们最多只能使用到2组Standby Redolog（一般情况我们只会只用到1组），这是因为Oracle对于SRL的启用机制就是从首个SRL开始找第一个可以使用的，正常情况下只有在接受下一次redo信息时，redo04.log还没有被归档成功，这时候才会使用redo05.log，而redo05被写满以后，redo04还没有被归档结束的情况我们几乎不可能碰到，所以下一次的redo信息又被写到redo04中。<br />而这次测试，由于B和C之间的网络中断，导致redo04－redo07这四组SRL都被启用了，并且再接下去RFS报了No standby redo logfiles的错误，这个同样很明显地表示了如果网络中断，在TimeOut时间内，redo是无法被正常归档的。<br />那么大家可能要问，如果B的4组SRL都无法使用了，A继续传过来的redo数据是不是也会被阻塞，从而也间接导致了A同样无法正常继续业务？<br />在测试之前，我也同样担心这个问题，但是测试表明这种情况没有出现。原因在于DataGuard的机制是，即使A指定了使用LGWR传递redo（如本例所示），如果出现B上的SRL无法使用的情况，B的RFS进程将把接受到的redo直接写入本机的Archivelog中，当A开始归档的时候，B同时归档刚才写入了数据的Archivelog（此归档的Sequence比A上归档的Sequence大1）。从下面的alertlog中可以确认这点：<br />ARC1: Evaluating archive   log 6 thread 1 sequence 600<br />ARC1: Beginning to archive log 6 thread 1 sequence 600<br />Creating archive destination LOG_ARCHIVE_DEST_2: 'CTSDB.STANDBY'<br />Creating archive destination LOG_ARCHIVE_DEST_1: '/oradata/ctsdb/archive/1_600.dbf'<br />ARC1: Completed archiving  log 6 thread 1 sequence 600</p>
<p>从以上的测试中我们得出一个结论，只要是Primary可以跟Standby的RFS进程正常通信，那么就不会产生操作被悬停的问题，不管Standby到底是使用了SRL还是使用了Archivelog。</p>
<p>最后，由于这样的环境添加了额外的机器（机器B），而由于DataGuard环境必须要求同构，所以如果整个环境是UNIX的，那么也许大家要问，这样岂不是需要再购买一台小型机，这在budget方面是不是就有些问题了。<br />确实，需要额外的投入，但是由于B机器只是作中转redo的作用，所以我们甚至可以不将B置于managed recover模式下，也就是B只负责接受A的redo，再把redo传送到C，这样对于B机器的性能要求就可以下降很多，也许一台普通的SunRay工作站就可以满足要求了。至于是不是确实可以满足性能需求，我还会有后续的测试。<br />呵呵，敬请期待。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 11:52:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%97%ae%e9%a2%98/" title="问题">问题</a>, <a href="https://www.iamivan.net/tag/primary/" title="primary">primary</a>, <a href="https://www.iamivan.net/tag/redo/" title="redo">redo</a>, <a href="https://www.iamivan.net/tag/archive/" title="archive">archive</a>, <a href="https://www.iamivan.net/tag/dataguard/" title="dataguard">dataguard</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>DataGuard - 利用Cascaded Redo Log Destinations避免WAN稳定性问题的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPOk98M.html" rel="bookmark">【DataGuard】10GR2 DataGuard的几个redo log相关问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.备库启动报redo log不存在的问题: 错误信息: Errors in file /home/oracle/admin/kgbdwmyj/bdump/kgbdwmyj_mrp0_11986.trc: ORA-00313: open failed for members of log group 2 of thread 1 ORA-00312: online log 2 thread 1: '/oradata/kgbdwmyj/redo02.log' ORA-27037: unable to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV94WYp.html" rel="bookmark">【体系结构】Oracle重做日志文件（Redo Log Files）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle重做日志文件 --========================================= -- Oracle 联机重做日志文件(ONLINE LOG FILE) --=========================================   一.oracle中的几类日志文件     Redo log files      --&gt;联机重做日志     Archive log files   --&gt;归档日志     Alert log files     --&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoV1Qb.html" rel="bookmark">MySQL&colon; 对超长blob列的redo log限制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道,Innodb使用固定长度的N个iblog文件来存储redo log,文件空间可以被复用.这些被复用的空间redo需要保证已经做了checkpoint. 假定我们的iblog大小为1G,如果我们更新一个非常大的字段,就有可能覆盖掉未checkpoint的redo log,因为Innodb并没有根据其可能产生的log长度来判断redo log空间是否够用.而只是保证会预留一定比例的redo log空间.详细见bug链接:http://bugs.mysql.com/bug.php?id=69			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAgOlM.html" rel="bookmark">Oracle Online Redo Log能否放在Flash闪存卡上？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Flash 闪存卡的性能远超SAS 盘,所以在数据库中使用广泛. 但是online redo log 是否应该存放在闪存卡上一直是有争议的话题.今天由DBA+社群合肥发起人戴明明来谈一谈他通过理论和实际的实验去测试这个问题.   专家简介     戴明明 DBA+社群合肥发起人   Oracle ACE Associate,中国 ORACLE 用户组(ACOUG) 核心成员,中国浙江应用中间件与数据库用户组成员. 超过7年的DBA经验,在Oracle 高可用性方面有一定的经验积累,擅长Oracl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZjKBz.html" rel="bookmark">Oracle高并发系列2：事务日志写入引发的Redo log风波</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者介绍 王鹏冲,平安科技数据库技术专家,浸淫数据库行业十多年,对Oracle数据库有浓厚兴趣,也对MySQL.MongoDB.Redis等数据库有一定架构和运维经验,目前正沉迷在PostgreSQL数据库与Oracle数据库的PK之中,重点在关系型数据库的分布式架构研究.   引言   关系型数据库强调事务的ACID特性,对于事务的持久性,主流的关系型数据库都是通过写事务日志来实现的.写数据是随机IO,写日志是顺序IO,常规的机械磁盘,随机IO比顺序IO要昂贵很多.所以虽然写日志同样要刷到磁盘			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrX6D6z.html" rel="bookmark">MySQL &CenterDot; 引擎特性 &CenterDot; InnoDB redo log漫游</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 InnoDB 有两块非常重要的日志,一个是undo log,另外一个是redo log,前者用来保证事务的原子性以及InnoDB的MVCC,后者用来保证事务的持久性. 和大多数关系型数据库一样,InnoDB记录了对数据文件的物理更改,并保证总是日志先行,也就是所谓的WAL,即在持久化数据文件前,保证之前的redo日志已经写到磁盘. LSN(log sequence number) 用于记录日志序号,它是一个不断递增的 unsigned long long 类型整数.在 InnoDB 的日志			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjL4Zmp.html" rel="bookmark">数据库内核月报 － 2015 &sol; 05-MySQL &CenterDot; 引擎特性 &CenterDot; InnoDB redo log漫游</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 InnoDB 有两块非常重要的日志,一个是undo log,另外一个是redo log,前者用来保证事务的原子性以及InnoDB的MVCC,后者用来保证事务的持久性. 和大多数关系型数据库一样,InnoDB记录了对数据文件的物理更改,并保证总是日志先行,也就是所谓的WAL,即在持久化数据文件前,保证之前的redo日志已经写到磁盘. LSN(log sequence number) 用于记录日志序号,它是一个不断递增的 unsigned long long 类型整数.在 InnoDB 的日志			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWWYweM.html" rel="bookmark">mysql源码-关于mysql redo log的问题。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于mysql redo log的问题. http://bugs.mysql.com/bug.php?id=73202 上面是一个官方的patch, According to the crash recovery logic of mysql server, we only need to write/sync prepared transaction before writing to binlog. And currently transactions are not groupe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7QaOrM.html" rel="bookmark">oracle-Redo log频繁切换问题，生成的archivelog文件远小于Redo log设置大小</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Redo log频繁切换问题,生成的archivelog文件远小于Redo log设置大小 Dear all, 遇到个问题Oracle DB Redo log每分钟差不多切换两次,设置的大小为600MB,但实际切换生成的archivelog文件只有1MB左右. 在alert log每分钟都有alter system archive log的记录,请教各位可能是什么原因造成?			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqNJap.html" rel="bookmark" class="title">PHP 安全及相关</a>
					<div>
						安全 关注安全问题的重要性 看到的远非全部 阻止用户恶意破坏你的程式最有效却经常被忽略的方法是在写代码时就考虑它的可能性.留意代码中可能的安全问题是很重要的.考虑下边的旨在简化用PHP中写入大量文本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYaE5M.html" rel="bookmark" class="title">Photoshop鼠绘教程&colon;简单绘制红苹果</a>
					<div>
						苹果的制作重点是表面的质感和光感的渲染.制作之前最好是先拿一些真实的苹果图片参靠一下,然后设定光源方向,再慢慢渲染光感,部分纹理可以用滤镜来完成.最终效果 1.新建文件800 * 800,选择钢笔工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ5ZKb.html" rel="bookmark" class="title">揭秘搜索引擎K网站的最新七种原因</a>
					<div>
						最近百度又进行了一次更新,而且很多网站遭受了很大的打击,原先排名在前几位的一下子就掉入了深渊,甚至在搜索结果后面的几十页,这让很多做流量站的站长痛不欲生,百度这次惩戒的力度很大,可是很多被惩罚的站长里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE08Jz.html" rel="bookmark" class="title">全选DataGrid里的复选框</a>
					<div>
						datagrid|复选框 我们经常会在DataGrid里选择一组数据,然后批量操作,如果要全部操作的话需要一个全选的功能,如果你用这个全选按钮的服务器端事件来让DataGrid里复选框的全选的话,会多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEll6Pz.html" rel="bookmark" class="title">php中如何计算两个文件之间的相对路径</a>
					<div>
						例如: 文件A 的路径是 /home/web/lib/img/cache.php 文件B的路径是 /home/web/api/img/show.php 那么,文件A相对于文件B的路径是 ../../l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyD6qb.html" rel="bookmark" class="title">使用windows vista自带硬盘驱动器查错工具来扫描硬盘驱动器</a>
					<div>
						vista自身携带了一个比较好的使用小工具可以扫描硬盘驱动器查找错误. 具体步骤如下: (1)打开我的&quot;计算机&quot;,然后随便找一个盘. (2)属性-&gt;工具选项卡-&gt;点击  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y8xkz.html" rel="bookmark" class="title">c&num;如何在类库里面共用连接</a>
					<div>
						private SqlConnection MyConn() { string setting = System.Configuration.ConfigurationManager.Connecti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElGYPz.html" rel="bookmark" class="title">Java多线程初学者指南（5）：join方法的使用</a>
					<div>
						在上面的例子中多次使用到了Thread类的join方法.我想大家可能已经猜出来join方法的功能是什么了.对,join方法的功能就是使异步执行的线程变成同步执行.也就是说,当调用线程实例的start方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7WXdM.html" rel="bookmark" class="title">可牛影像怎么制作窗格效果照片</a>
					<div>
						  窗格效果照片一直有一种朦胧之美,相信很多人在看到窗格效果照片之后也想自己制作一张,但是不知道要怎么做.今天,小编就来跟大家分享可牛影像怎么制作窗格效果照片. 先看一下效果图: 可牛影像 首先,运行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEoVyb.html" rel="bookmark" class="title">迅雷5&period;9常用快捷键 让你快如闪电</a>
					<div>
						巧妙地利用快捷键,可以大大加快我们操作电脑的速度.因此,研究并有针对性地记忆一下相应软件的快捷键对自己很有好处!迅雷5.9是我们平时下载时的最爱,它同样支持很多的快捷键,掌握了这些快捷键,能让我们的下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPyaZz.html" rel="bookmark" class="title">Win7系统如何获取文件完整路径</a>
					<div>
						先在Win7的资源管理中找到目标文件或者文件夹,然后按住Shift键,用鼠标右键点击目标文件或者文件夹,在右键菜单中选择&quot;复制为路径&quot;,这个文件和或者文件夹的完整路径就会粘贴到我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o9Vnb.html" rel="bookmark" class="title">美图秀秀将普通街景照片变成复古明信片</a>
					<div>
						大家外出旅游都喜欢将游览过的地方建筑和街景拍下来留念.不过这种照片拍太多会感觉差别不大,如何将这样的街景照改造的更有创意呢?小编倒是有一招可以跟大家分享,那就是用&quot;美图秀秀&quot;软件将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24dJvp.html" rel="bookmark" class="title">CAD要怎么样才能将线段打断</a>
					<div>
						将一条直线切断分为两部分的方法叫做打断.这方法的好处就是可以直接修改一开始就合为一体画,到后续发现需要分开才行的图纸.下面来看看CAD怎么才能打断线段. 1.在CAD界面内找到打断的符号,点击打开,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6QNPM.html" rel="bookmark" class="title">java  并发的问题</a>
					<div>
						问题描述 我先贴一下代码: boolean flag=false; List&lt;UserBean&gt; list=null; UserDao userDao=new UserDaoImpl(); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8k00VM.html" rel="bookmark" class="title">《iOS 6核心开发手册（第4版）》&mdash;&mdash;2&period;16节秘诀：创建可自定义的分页滚动条</a>
					<div>
						2.16 秘诀:创建可自定义的分页滚动条 iOS 6核心开发手册(第4版) 程序清单2-1引入了一个基本的分页滚动条,但是没有给方程式添加任何动态交互.那个示例开始和结束于3个页面.在现实生活中,当可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxAPdb.html" rel="bookmark" class="title">关于数据库中的弱实体</a>
					<div>
						问题描述 关于数据库中的弱实体 数据库中,设计的ER图里面弱实体A依赖于弱实体B的话,是否需要将弱实体B中的主键放去弱实体A中充当主键? 解决方案 数据库实体					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94nGKb.html" rel="bookmark" class="title">AngularJS 实践：应用开发 &colon;&colon; ENA13 价格条码-&lpar;二&rpar;</a>
					<div>
						上一节咱们做了个基本介绍和预备工作.这一节我们将进入应用实现前的开发工作流工具和环境准备. 上一节参考: AngularJS 实践:应用开发 :: ENA13 价格条码-(一) 创建开发环境和工作目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqOVWz.html" rel="bookmark" class="title">htop 1&period;0&period;1发布 Linux交互式进程浏览器</a>
					<div>
						htop 是一个运行于Linux的交互式进程的浏览器,其目标是成为一个更好的 'top' 命令.它是一种文本模式应用程序(控制台或X终端),支持垂直和水平滚动进程列表,当前版本经过 Linux 2.4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE43a9z.html" rel="bookmark" class="title">今天&comma;你有没有给身边的人一个温暖的问候？</a>
					<div>
						从写信到今天的短信.电话.QQ.微博@你 从&quot;吃了吗&quot;到今天的&quot;旅游了吗&quot;&quot;电影了吗&quot; &quot;世界问候日&quot;为了世界和平而诞生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrq2G4b.html" rel="bookmark" class="title">SQL Server触发器</a>
					<div>
						触发器可以做很多事情,但也会带来很多问题.使用它的技巧在于在适当的时候使用,而不要在不适当的时候使用它们. 触发器的一些常见用途如下: 弹性参照完整性:实现很多DRI不能实现的操作(例如,跨数据库或服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodNLEM.html" rel="bookmark" class="title">PHP 15&colon;异常</a>
					<div>
						原文:PHP 15:异常看完了out_put_fns.php文件,让我们再看看db_fns.php文件.其代码非常简单,如下:  1 &lt;?php 2  3 function db_connect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmGo2z.html" rel="bookmark" class="title">西媒惊爆曼联今夏首签创纪录1700万镑购西国门</a>
					<div>
						上周末曾有消息称,本周弗格森度假回来就会着手进行转会工作,果然,当地时间周一下午,就有西班牙媒体披露,曼联已经和维拉里尔的西班牙国门迭戈-洛佩斯预签了一份合同,转会费是1700万镑. 本来此前&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jxYvp.html" rel="bookmark" class="title">提问的智慧&lowbar;php基础</a>
					<div>
						提问的智慧 Copyright (C) 2001 by Eric S. Raymond 中文版Copyleft 2001 by D.H.Grand(nOBODY/Ginux) 英文版:http://w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NN73p.html" rel="bookmark" class="title">浏览器兼容常见问题介绍&lpar;ff&comma;ie&comma;Chrome&rpar;总结</a>
					<div>
						突然间,在Chrome下看起来很整齐的布局,在IE下变成一团糟.为了找出原因,我改动了div的background-color属性.最后,发现同一个DIV的宽度在IE和Chrome下却不一样.这大晚上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NNnBb.html" rel="bookmark" class="title">如何实现php图片等比例缩放&lowbar;php技巧</a>
					<div>
						通过文章给出的源代码可实现针对图片的等比缩放生成缩略图的功能,非常实用的技巧哦. 新建文件index.php,需要在统计目录下有个图片为pic.jpg(可根据源码进行更改图片的名称) 源代码如下: & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm09Np.html" rel="bookmark" class="title">C&plus;&plus;实现显示MP3文件信息的方法&lowbar;C 语言</a>
					<div>
						本文实例讲述了C++实现显示MP3文件信息的方法.分享给大家供大家参考.具体实现方法如下: /** * This is small example how to use libZPlay librar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk7Zrp.html" rel="bookmark" class="title">测试-hibernate   求各位大神 帮忙看一下</a>
					<div>
						问题描述 hibernate 求各位大神 帮忙看一下 我做的一个Hibernate 一对多 多对一的 保存和读取操作 保存 没问题 但是 读取那老是提示 内存溢出 下面是 实体类 Department ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAWADp.html" rel="bookmark" class="title">程序员应该养成写作的习惯</a>
					<div>
						摘要: 在学校里,有文科生和理科生的区分,学习内容不同,思维方式也有差异.我是一名理科生,大学里我的专业是计算机科学,毕业后我的工作是软件工程师.在这个过程中,我发现文理 在学校里,有&quot;文科 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWmd0M.html" rel="bookmark" class="title">asp无需配置iis实现伪静态的例子</a>
					<div>
						&lt;!--#include file=&quot;config.asp&quot;--&gt;    &lt;ol&gt;    &lt;%    Set rs=server.CreateObje ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GXxBM.html" rel="bookmark" class="title">与A Wireless公司签订合作 网秦收盘大涨21&percnt;</a>
					<div>
						网秦(NYSE:NQ),公司与A Wireless公司签订合作协议,将为后者提供用户移动设备与数据的安全服务.A Wireless是运营商Verizon的无线业务高级合作伙伴.截至收盘,网秦(NYSE ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
